

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.19. snippet_html &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.20. string_length" href="string_length.html" />
    <link rel="prev" title="7.15.18. rand" href="rand.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/snippet_html.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="string_length.html" title="7.15.20. string_length"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="snippet-html">
<h1><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code><a class="headerlink" href="#snippet-html" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.19.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> は対象テキスト中から検索キーワード周辺のテキスト（ <code class="docutils literal notranslate"><span class="pre">KWIC</span></code> 。 <code class="docutils literal notranslate"><span class="pre">KeyWord</span> <span class="pre">In</span> <span class="pre">Context</span></code> ）を抽出します。抽出されたテキストのことをスニペットと呼びます。スニペットはHTML中に埋め込みやすいように処理されています。 <code class="docutils literal notranslate"><span class="pre">&lt;</span></code> や <code class="docutils literal notranslate"><span class="pre">&gt;</span></code> などの特殊文字は <code class="docutils literal notranslate"><span class="pre">&amp;lt;</span></code> や <code class="docutils literal notranslate"><span class="pre">&amp;gt;</span></code> にエスケープされています。キーワードは <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> で囲まれています。たとえば、 <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span> <span class="pre">groonga</span> <span class="pre">user.</span> <span class="pre">&lt;3</span></code> という対象テキストのキーワード <code class="docutils literal notranslate"><span class="pre">groonga</span></code> でのスニペットは <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span> <span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;groonga&lt;/span&gt;</span> <span class="pre">user.</span> <span class="pre">&amp;lt;3</span></code> となります。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.19.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> の引数は1つだけです:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>snippet_html(column)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> は内部にはたくさんのオプションがありますが、今はまだ指定できません。じきに指定できるようになる予定です。</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.19.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Documents TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Documents content COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms documents_content_index COLUMN_INDEX|WITH_POSITION Documents content
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Documents
[
[&quot;content&quot;],
[&quot;Groonga is a fast and accurate full text search engine based on inverted index. One of the characteristics of groonga is that a newly registered document instantly appears in search results. Also, groonga allows updates without read locks. These characteristics result in superior performance on real-time applications.&quot;],
[&quot;Groonga is also a column-oriented database management system (DBMS). Compared with well-known row-oriented systems, such as MySQL and PostgreSQL, column-oriented systems are more suited for aggregate queries. Due to this advantage, groonga can cover weakness of row-oriented systems.&quot;]
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> は <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドの <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> 内でのみ指定できます。</p>
<p>また、 <code class="docutils literal notranslate"><span class="pre">--query</span></code> と <code class="docutils literal notranslate"><span class="pre">--filter</span></code> オプションも指定する必要があります。（どちらか一方でも構いません。）これは、 <code class="docutils literal notranslate"><span class="pre">--query</span></code> と <code class="docutils literal notranslate"><span class="pre">--filter</span></code> オプションからキーワードを抽出しているためです。</p>
<p>以下の例は <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;fast</span> <span class="pre">performance&quot;</span></code> を使っています。この場合は、キーワードとして <code class="docutils literal notranslate"><span class="pre">fast</span></code> と <code class="docutils literal notranslate"><span class="pre">performance</span></code> を使います。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Documents --output_columns &quot;snippet_html(content)&quot; --command_version 2 --match_columns content --query &quot;fast performance&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;snippet_html&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;Groonga is a &lt;span class=\&quot;keyword\&quot;&gt;fast&lt;/span&gt; and accurate full text search engine based on inverted index. One of the characteristics of groonga is that a newly registered document instantly appears in search results. Also, gro&quot;,
#           &quot;onga allows updates without read locks. These characteristics result in superior &lt;span class=\&quot;keyword\&quot;&gt;performance&lt;/span&gt; on real-time applications.&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;fast</span> <span class="pre">performance&quot;</span></code> は最初のレコードの内容にだけマッチします。 <code class="docutils literal notranslate"><span class="pre">snippet_html(content)</span></code> は、テキスト中からキーワード <code class="docutils literal notranslate"><span class="pre">fast</span></code> と <code class="docutils literal notranslate"><span class="pre">performance</span></code> の少なくともどちらか一方を含んでいるテキストの断片を抽出します。今回は2箇所抽出しています。そして、抽出したテキストの断片内にあるキーワードを <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> で囲みます。</p>
<p>テキストの断片数は多くても3です。4つ以上のテキストの断片が抽出できるときは、最初の3つだけを使います。</p>
<p>テキストの断片の最大サイズは200バイトです。単位は文字数ではなくバイトです。挿入される <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> のバイト数はこのサイズの中には含まれません。</p>
<p>テキストの断片の最大数とテキストの断片の最大サイズはカスタマイズできません。</p>
<p>カラムの代わりに文字列リテラルを指定することもできます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Documents --output_columns &#39;snippet_html(&quot;Groonga is very fast fulltext search engine.&quot;)&#39; --command_version 2 --match_columns content --query &quot;fast performance&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;snippet_html&quot;,
#           null
#         ]
#       ],
#       [
#         [
#           &quot;Groonga is very &lt;span class=\&quot;keyword\&quot;&gt;fast&lt;/span&gt; fulltext search engine.&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.19.4. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> は文字列の配列もしくは <code class="docutils literal notranslate"><span class="pre">null</span></code> を返します。 <code class="docutils literal notranslate"><span class="pre">snippet_html</span></code> は該当するスニペットがない場合に <code class="docutils literal notranslate"><span class="pre">null</span></code> を返します。</p>
<p>配列の要素がスニペットになります:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[SNIPPET1, SNIPPET2, SNIPPET3]
</pre></div>
</div>
<p>スニペットには1つ以上のキーワードが含まれています。 <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> を除いたスニペットの最大サイズは200byteです。単位は文字数ではなくてバイトです。</p>
<p>配列のサイズは0以上3以下です。最大サイズの3は、じきにカスタマイズできるようになる予定です。</p>
</div>
<div class="section" id="todo">
<h2><span class="section-number">7.15.19.5. </span>TODO<a class="headerlink" href="#todo" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p>テキストの断片の最大数をカスタマイズできるようにする。</p></li>
<li><p>テキストの断片最大サイズをカスタマイズできるようにする。</p></li>
<li><p>キーワードをカスタマイズできるようにする。</p></li>
<li><p>キーワードを囲むタグをカスタマイズできるようにする。</p></li>
<li><p>正規化の方法をカスタマイズできるようにする。</p></li>
<li><p>オブジェクトリテラル形式でのオプション指定をサポートする。</p></li>
</ul>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.19.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.19. <code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.19.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.19.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.19.3. 使い方</a></li>
<li><a class="reference internal" href="#return-value">7.15.19.4. 戻り値</a></li>
<li><a class="reference internal" href="#todo">7.15.19.5. TODO</a></li>
<li><a class="reference internal" href="#see-also">7.15.19.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="rand.html"
                        title="前の章へ"><span class="section-number">7.15.18. </span>rand</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="string_length.html"
                        title="次の章へ"><span class="section-number">7.15.20. </span><code class="docutils literal notranslate"><span class="pre">string_length</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="string_length.html" title="7.15.20. string_length"
             >次へ</a> |</li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.19. </span><code class="docutils literal notranslate"><span class="pre">snippet_html</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>